//------------------------------------------------------------
//////// Script constants
var DEFAULT_INT=-1;
var DEFAULT_STRING='';
var DEFAULT_BOOLEAN=false;
//------------------------------------------------------------


//------------------------------------------------------------
/////// Airbox constants
var WESCO_AIRBOX_EAN = "7630019804721"
/*Maximum number of times an airbox is read and written*/
var AIRBOX_READ_MAX_RETRY=3;
var AIRBOX_WRITE_MAX_RETRY=3;

var FilterReplacementInterval=365; // in days

// dSTiny variables
var DSTINY_REG_BANK = 0x7F;
var AIRBOX_COMMAND_REG=3;
var AIRBOX_LEVEL_REG = 1;
var FIRMWARE_VERSION_REG=62;
var LIMMATTOWER_FIRMWARE_VERSION=0x30;
var AIRBOX_MAX_TIME_BTW_ERRORS=30000; // seconds
var AIRBOX_CLEARERROR_NTRIES=4;
var AIRBOX_ERROR_EVENT_STATUS_INDEX=24;
var AIBOX_LEVEL_REG = 1;
var AIRBOX_LEVEL_NREGS=3; // number of level registers

var AIRBOX_MINIMUM_LEVEL_REG = 13;
var AIRBOX_MEDIUM_LEVEL_REG = 14;
var AIRBOX_NOMINAL_LEVEL_REG = 15;
var AIRBOX_MINIMUM_LEVEL_DEFAULT = 101;
var AIRBOX_MEDIUM_LEVEL_DEFAULT = 120;
var AIRBOX_NOMINAL_LEVEL_DEFAULT = 139;

// Error codes
var AIRBOX_POWER_ERR=128;
var AIRBOX_SENSOR_ERR=130;
var AIRBOX_FAN_ERR=132;
var AIRBOX_FLAP_ERR=136;
var AIRBOX_FROST_ERR=144;
//------------------------------------------------------------



//------------------------------------------------------------
//// Controller constants
var AIRBOX_DEFAULT_LEVEL=2; // Medium
//------------------------------------------------------------


//------------------------------------------------------------
///////// Debug constants

//var AIRBOX_ERROR_LOG="wesco_airbox_error.log"
var SCRIPT_LOG="wesco.log"
var DEBUG_LOG="wesco_debug.log"

var DebugLog= new Logger(DEBUG_LOG);
var WESCO_logger=new Logger(SCRIPT_LOG);

var VerboseMode=false;
//------------------------------------------------------------



// Error codes for the log files
var ErrorCodes={"no_error":"NOERROR",
		"timeout_error":"TMOUTERR",
		"power_error":"POWERERR",
		"sensor_error":"SENSORERR",
		"fan_error":"FANERR",
		"flap_error":"FLAPERR",
		"frost_warning":"FROSTWAR",
		"frost_error":"FROSTERR",
	        "deleted_from_propTree":"AIRBOXLOST",
		"registered_to_propTree":"NEWAIRBOX"
	       };




function debug(type,message){
    // Writes
    //Events with type DEBUG are only printed if the variable VerboseMode is true.

    if (VerboseMode){
	DebugLog.logln(";"+type+";"+message);
    }
}

function WESCOLog(Type,dsid,ErrorCode,Message){
    // Type in [E:error,W:warning,I:info]

    // if dsid is 0,  then the error belongs to the script and not to an airbox in particular

    // Message can be emptied
    WESCO_logger.logln(";"+Type+";"+ErrorCode+";"+dsid+";"+Message);
}
